/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.data;

/**
 *
 * @author simone
 */
public class MatrixIntervalList extends IntervalList {
    private int columnsNumber;

    public MatrixIntervalList() {
        this.columnsNumber = -1;
    }

    public MatrixIntervalList(int columnsNumber) {
        this.columnsNumber = columnsNumber;
    }

    public MatrixIntervalList (Interval i, int columnsNumber) {
       add (i);
       this.columnsNumber = columnsNumber;
    }

    public MatrixIntervalList (IntervalList i) {
       super (i);
       if (i.isMatrix()) columnsNumber = i.getColumns(); //very important
       else columnsNumber = -1;
    }

    public MatrixIntervalList (IntervalList i, int columnsNumber) {
       super (i);
       this.columnsNumber = columnsNumber;
    }

    public MatrixIntervalList (MatrixIntervalList i) {
       super (i);
       columnsNumber = i.columnsNumber;
    }

    @Override
    public int getColumns() {
        if (columnsNumber <= 0) return size();
        return columnsNumber;
    }

    @Override
    public int getRows () {
        if (columnsNumber <= 0) return 1;
        return size()/columnsNumber;
    }

    @Override
    public Interval get (int row, int column) {
        if (row > getRows() || column > getColumns()) throw new RuntimeException("Intex out of bound");
        return get (row*columnsNumber+column);
    }

    @Override
    public void set(int row, int column, Interval val) {
        if (row > getRows() || column > getColumns()) throw new RuntimeException("Intex out of bound");
        set (row*columnsNumber+column, val);
    }

    @Override
    public boolean isProperMatrix () {
        return isMatrix() && size()%columnsNumber==0;
    }

    @Override
    public boolean isMatrix() {
        return columnsNumber > 0;
    }

    @Override
    public String toString () {
        if (! isMatrix()) return super.toString();

        StringBuffer result = new StringBuffer ();
        if (size() == 0) return result.toString();
        int col = columnsNumber;
        result.append ("\n[");
        result.append(get(0).toStringSpaced());
        for (int i=1; i<size(); ++i) {
            result.append("  ");

            if (columnsNumber > 0 && --col <= 0) {
                result.append("]\n[");
                col = columnsNumber;
            }

            result.append(get(i).toStringSpaced());
        }
        result.append("  ]");
        return result.toString();
    }

}
