/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.expression.token;

import engcalculator.data.IntervalList;
import engcalculator.data.Literal;

/**
 *
 * @author simone
 */
public class LiteralTkn extends Token {
    private final static PrefixFunctionTkn PREFIX_FUNCTION_TKN = new PrefixFunctionTkn ();
    private final static VariableTkn VARIABLE_TKN = new VariableTkn();

    private Literal literal;
    private boolean notConvertibleToVarFun;

    public LiteralTkn() {
        notConvertibleToVarFun = false;
    }

    private LiteralTkn(String literal) {
        super (literal);
        this.literal = new Literal (literal);
    }

    @Override
    public Token regenerateToken() {
        if (notConvertibleToVarFun) return super.regenerateToken();
        Token t;
        t = VARIABLE_TKN.generateToken(getSymbol());
        if (t != null) return t;
        t = PREFIX_FUNCTION_TKN.generateToken(getSymbol());
        if (t != null) return t;
        return super.regenerateToken();
    }

    @Override
    public IntervalList getIntervalList() {
        return new IntervalList (literal);
    }

    @Override
    public Token generateToken(String symbol) {
        if (isDefiningFunction()) return null; //it makes no sense to use literals defining functions

        boolean nc = false;
        if (symbol.length() > 2) {
            char startc = symbol.charAt(0), endc = symbol.charAt(symbol.length()-1);
            if (startc == endc && startc == '\'') {
                symbol = symbol.substring(1,  symbol.length()-1);
                nc = true; //if something is between apices it cannot be converted back to variable of function
            }
        }

        LiteralTkn lt = new LiteralTkn(symbol);
        if (nc) lt.notConvertibleToVarFun = true;
        return lt;
    }

    @Override
    public boolean mayBeCompatible( String symbol) {
        if (PREFIX_FUNCTION_TKN.mayBeCompatible(symbol)) return true;
        if (symbol.charAt(0) == '\'') {
            if (symbol.length() > 1) {
                int ea = symbol.indexOf('\'', 1);
                if (ea > -1 && ea < symbol.length()-1) return false;
            }
            return true;
        } else {
            if ( ! Character.isLetter(symbol.charAt(0))) return false;
            for (char c : symbol.toCharArray())
                if (! Character.isLetterOrDigit(c)) return false;
            return true;
        }
    }

}
