/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.expression.token;

import engcalculator.expression.Tokenizer;
import engcalculator.data.IntervalList;
import engcalculator.function.prefix.PrefixFunction;

/**
 *
 * @author simone
 */
public class ParameterTkn extends PrefixFunctionTkn {//late binding functin known by name
    private Tokenizer tokenizer;

    public ParameterTkn (Tokenizer tokenizer) {
        this.tokenizer = tokenizer;
    }

    private ParameterTkn (String functionName, Tokenizer tokenizer) {
        super (functionName, null);
        this.tokenizer = tokenizer;
    }

    @Override
    public PrefixFunction getPrefixFunction () {
        PrefixFunction f = tokenizer.getParameters().get(getSymbol());
        if (f == null || f.getNumbArgs() == 0) return null;
        return f;
    }

    @Override
    public IntervalList getIntervalList() throws Exception {
        PrefixFunction f = tokenizer.getParameters().get (getSymbol());
        if (f == null || f.getNumbArgs() > 0) return null;
        return f.compute(new IntervalList());
    }

    @Override
    public Token generateToken(String symbol) {
        if (! (isDefiningFunction() && tokenizer.getParametersName().contains(symbol))) return null;
        return new ParameterTkn(symbol, tokenizer);
    }

    @Override
    public boolean isVariable() {
        return true;
    }
}
