/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.expression.token;

import engcalculator.function.prefix.PrefixFunction;

/**
 *
 * @author simone
 */
public class PrefixFunctionTkn extends Token {

    private PrefixFunction prefixFunction;

    public PrefixFunctionTkn() {}

    protected PrefixFunctionTkn(String function, PrefixFunction prefixFunction) {
        super (function);
        this.prefixFunction = prefixFunction;
    }

    @Override
    public PrefixFunction getPrefixFunction () {
        return prefixFunction;
    }

    @Override
    public Token generateToken(String symbol) {
        PrefixFunction f = PrefixFunction.getFunction (symbol);
        if (f != null) return new PrefixFunctionTkn(symbol, f);
        return null;

    }

    @Override
    public boolean mayBeCompatible( String symbol) {
        if ( ! (Character.isLowerCase(symbol.charAt(0)) || Character.isUpperCase(symbol.charAt(0)) ) )return false;
        for (char c : symbol.toCharArray())
            if (! (Character.isLowerCase(c) || Character.isUpperCase(c) || Character.isDigit(c))) return false;
        return true;
    }
}
